# Note: the next six lines are modified by the makefile-generator in xcowlite.x.
APP       = matrix
LIBS      = xb.lib glfw.lib opengl32.lib glu32.lib kernel32.lib msvcrt.lib
OBJS      = xstart.o $(APP).o
START     = START /W
XBLITE    = xblite
SUBSYSTEM = WINDOWS,4.0

# The linker
LD          = link

# Flags for the linker
LDFLAGS     = /NODEFAULTLIB /SUBSYSTEM:$(SUBSYSTEM) /INCREMENTAL:NO /RELEASE /NOLOGO /OPT:REF /ALIGN:4096

# Flags for the linker when building .dll-files
LDFLAGS_DLL = -dll -subsystem:$(SUBSYSTEM)

# Needed resources
RESOURCES   = $(APP).rbj

# The assembler
AS          = spasm

# All needed standard libraries.
STDLIBS     = msvcrt.lib kernel32.lib advapi32.lib user32.lib gdi32.lib comdlg32.lib winspool.lib

# The main directory for \xblite 
DIR         = $(XBLDIR)

#!include <xbasic.mak>

all: $(APP).exe

$(APP).exe: $(APP).o $(RESOURCES)
	$(LD) $(LDFLAGS) -out:$(APP).exe $(OBJS) $(RESOURCES) $(LIBS) $(STDLIBS)

$(APP).rbj: $(APP).res
	cvtres -i386 -NOLOGO $(APP).res -o $(APP).rbj

$(APP).res: $(APP).rc
	rc -i$(DIR)\images -r -fo $(APP).res $(APP).rc

$(APP).o: $(APP).s
	$(AS) $(APP).s

$(APP).s: $(APP).x
	$(START) $(XBLITE) $(APP).x

clean:
	DEL $(APP).res
	DEL $(APP).rbj
	DEL $(APP).def
	DEL $(APP).o
	DEL $(APP).s
	DEL $(DIR)\programs\$(APP).exe
	COPY $(APP).exe $(DIR)\programs\$(APP).exe
	START $(DIR)\programs\$(APP).exe
